from enum import Enum
from plum import dispatch
from typing import TypeVar,Union,Generic,List,Tuple
from spire.xls.common import *
from spire.xls import *
from ctypes import *
import abc

class PaperSizeType(Enum):
    """
    <summary>
        Paper size type.
    </summary>
    """
    Paper10x14 = 16
    Paper11x17 = 17
    PaperA3 = 8
    PaperA4 = 9
    PaperA4Small = 10
    PaperA5 = 11
    PaperB4 = 12
    PaperB5 = 13
    PaperCSheet = 24
    PaperDSheet = 25
    PaperEnvelope10 = 20
    PaperEnvelope11 = 21
    PaperEnvelope12 = 22
    PaperEnvelope14 = 23
    PaperEnvelope9 = 19
    PaperEnvelopeB4 = 33
    PaperEnvelopeB5 = 34
    PaperEnvelopeB6 = 35
    PaperEnvelopeC3 = 29
    PaperEnvelopeC4 = 30
    PaperEnvelopeC5 = 28
    PaperEnvelopeC6 = 31
    PaperEnvelopeC65 = 32
    PaperEnvelopeDL = 27
    PaperEnvelopeItaly = 36
    PaperEnvelopeMonarch = 37
    PaperEnvelopePersonal = 38
    PaperEsheet = 26
    PaperExecutive = 7
    PaperFanfoldLegalGerman = 41
    PaperFanfoldStdGerman = 40
    PaperFanfoldUS = 39
    PaperFolio = 14
    PaperLedger = 4
    PaperLegal = 5
    PaperLetter = 1
    PaperLetterSmall = 2
    PaperNote = 18
    PaperQuarto = 15
    PaperStatement = 6
    PaperTabloid = 3
    PaperUser = 256
    ISOB4 = 42
    JapaneseDoublePostcard = 43
    StandardPaper9By11 = 44
    StandardPaper10By11 = 45
    StandardPaper15By11 = 46
    InviteEnvelope = 47
    LetterExtraPaper9275By12 = 50
    LegalExtraPaper9275By15 = 51
    TabloidExtraPaper = 52
    A4ExtraPaper = 53
    LetterTransversePaper = 54
    A4TransversePaper = 55
    LetterExtraTransversePaper = 56
    SuperASuperAA4Paper = 57
    SuperBSuperBA3Paper = 58
    LetterPlusPaper = 59
    A4PlusPaper = 60
    A5TransversePaper = 61
    JISB5TransversePaper = 62
    A3ExtraPaper = 63
    A5ExtraPpaper = 64
    ISOB5ExtraPaper = 65
    A2Paper = 66
    A3TransversePaper = 67
    A3ExtraTransversePaper = 68
    PaperJapaneseDoublePostcard = 69
    A6Paper = 70
    PaperJapaneseEnvelopeKaku2 = 71
    PaperJapaneseEnvelopeKaku3 = 72
    PaperJapaneseEnvelopeChou3 = 73
    PaperJapaneseEnvelopeChou4 = 74
    PaperLetterRotated = 75
    PaperA3Rotated = 76
    PaperA4Rotated = 77
    PaperA5Rotated = 78
    PaperJISB4Rotated = 79
    PaperJISB5Rotated = 80
    PaperJapanesePostcardRotated = 81
    PaperJapaneseDoublePostcardRotated = 82
    PaperA6Rotated = 83
    PaperJapaneseEnvelopeKaku2Rotated = 84
    PaperJapaneseEnvelopeKaku3Rotated = 85
    PaperJapaneseEnvelopeChou3Rotated = 86
    PaperJapaneseEnvelopeChou4Rotated = 87
    PaperJISB6 = 88
    PaperJISB6Rotated = 89
    Paper12x11 = 90
    PaperJapaneseEnvelopeYou4 = 91
    PaperJapaneseEnvelopeYou4Rotated = 92
    PaperPRC16K = 93
    PaperPRC32K = 94
    PaperPRCBig32K = 95
    PaperPRCEnvelope1 = 96
    PaperPRCEnvelope2 = 97
    PaperPRCEnvelope3 = 98
    PaperPRCEnvelope4 = 99
    PaperPRCEnvelope5 = 100
    PaperPRCEnvelope6 = 101
    PaperPRCEnvelope7 = 102
    PaperPRCEnvelope8 = 103
    PaperPRCEnvelope9 = 104
    PaperPRCEnvelope10 = 105
    PaperPRC16KRotated = 106
    PaperPRC32KRotated = 107
    PaperPRCBig32KRotated = 108
    PaperPRCEnvelope1Rotated = 109
    PaperPRCEnvelope2Rotated = 110
    PaperPRCEnvelope3Rotated = 111
    PaperPRCEnvelope4Rotated = 112
    PaperPRCEnvelope5Rotated = 113
    PaperPRCEnvelope6Rotated = 114
    PaperPRCEnvelope7Rotated = 115
    PaperPRCEnvelope8Rotated = 116
    PaperPRCEnvelope9Rotated = 117
    PaperPRCEnvelope10Rotated = 118
    Custom = 32767

