from enum import Enum
from plum import dispatch
from typing import TypeVar,Union,Generic,List,Tuple
from spire.xls.common import *
from spire.xls import *
from ctypes import *
import abc

class VPageBreak (  XlsVPageBreak) :
    """
    <summary>
        Represents a vertical page break.
    </summary>
    """
    @property

    def Location(self)->'CellRange':
        """
    <summary>
        Returns or sets the cell (a Range object) that defines the page-break location.
    </summary>
        """
        GetDllLibXls().VPageBreak_get_Location.argtypes=[c_void_p]
        GetDllLibXls().VPageBreak_get_Location.restype=c_void_p
        intPtr = CallCFunction(GetDllLibXls().VPageBreak_get_Location, self.Ptr)
        ret = None if intPtr==None else CellRange(intPtr)
        return ret


    @Location.setter
    def Location(self, value:'CellRange'):
        GetDllLibXls().VPageBreak_set_Location.argtypes=[c_void_p, c_void_p]
        CallCFunction(GetDllLibXls().VPageBreak_set_Location, self.Ptr, value.Ptr)

